=== contrib/debian/control ===
Source: netdata
Build-Depends: debhelper (>= 9.20160709),
               dh-autoreconf,
               dpkg-dev (>= 1.13.19),
               zlib1g-dev,
               uuid-dev,
               libelf-dev,
               libuv1-dev,
               liblz4-dev,
               libjudy-dev,
               libssl-dev,
               libmnl-dev,
               libjson-c-dev,
               libcups2-dev,
               libipmimonitoring-dev,
               libnetfilter-acct-dev,
               libsnappy-dev,
               libprotobuf-dev,
               libprotoc-dev,
               cmake,
               autogen,
               autoconf,
               automake,
               pkg-config,
               curl,
               protobuf-compiler
Section: net
Priority: optional
Maintainer: Netdata Builder <bot@netdata.cloud>
Standards-Version: 3.9.6
Homepage: https://netdata.cloud

Package: netdata
Architecture: any
Depends: adduser,
         libcap2-bin (>= 1:2.0),
         lsb-base (>= 3.1-23.2),
         openssl,
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: netdata-core,
           netdata-plugins-bash,
           netdata-plugins-python,
           netdata-web
Pre-Depends: dpkg (>= 1.17.14)
Description: real-time charts for system monitoring
 Netdata is a daemon that collects data in realtime (per second)
 and presents a web site to view and analyze them. The presentation
 is also real-time and full of interactive charts that precisely
 render all collected values.

Package: netdata-plugin-cups
Architecture: any
Depends: cups,
         ${shlibs:Depends},
         netdata (>= ${source:Version})
Description: The Common Unix Printing System plugin for metrics collection from cupsd

Package: netdata-plugin-freeipmi
Architecture: any
Depends: freeipmi,
         ${shlibs:Depends},
         netdata (= ${source:Version})
Description: FreeIPMI - The Intelligent Platform Management System.
 The IPMI specification defines a set of interfaces for platform management.
 It is implemented by a number vendors for system management. The features of IPMI that most users will be interested in
 are sensor monitoring, system event monitoring, power control, and serial-over-LAN (SOL).
